package com.cyara.apisamples;

import javax.json.JsonArray;
import javax.json.JsonObject;

/**
 * A basic program to grab all your Pulse calls from a designated
 * timestamp and print out how many failed out of how may calls.
 * <p>
 * This is not an official Cyara product and is not officially supported.
 * It is used for demonstration and training purposes. For assistance,
 * contact chris.ryan@cyara.com
 * 
 * @author Chris Ryan
 * @version 1.1
 */
public class CyaraPulseProcessing {
	public static void main(String[] argv) {
		ApiFunctionalities connInfo = new ApiFunctionalities();

		int totalCalls = 0;
		int totalFails = 0;

		boolean morePages = true;
		String nextPage = "";

		JsonObject apiObject = connInfo.getTestResultsFeed("pulse", "fromDate", "2020-12-01T12:43:58Z");

		//Main loop to keep grabbing more calls
		while (morePages) {
			if (apiObject.containsKey("nextLink")) {
				String selfLink = apiObject.getString("selfLink");
				String nextLink = apiObject.getString("nextLink");
				if (selfLink.equals(nextLink)) {
					morePages = false;
				}
				else {
					nextPage = apiObject.getString("nextLink");
				}

				JsonArray resultsArr = apiObject.getJsonArray("results");
				for (int resultIndex = 0; resultIndex < resultsArr.size(); resultIndex++) {
					totalCalls++;

					//Get specific call
					JsonObject previousResult = resultsArr.getJsonObject(resultIndex);

					//Get the test result object of the call
					JsonObject callTestResult = previousResult.getJsonObject("testResult");

					//Get the result from the result object
					String callResult = callTestResult.getString("result");

					if (callResult.equals("Failed")) {
						totalFails++;
						//In here you could further process previousResult by step
					}
				}
			}
			else { //nextPage doesn't even exist, something is totally wrong
				morePages = false;
			}

			if (morePages) { //After processing that call, do we still have pages? Then make the next call here
				apiObject = connInfo.convertAPIOutputToJson(connInfo.makeApiGet(nextPage));
			}
		}

		System.out.println("Total failures: " + totalFails + " out of " + totalCalls + " calls.");

	}

}
