package com.cyara.apisamples;

import java.util.ArrayList;

import javax.json.JsonArray;
import javax.json.JsonObject;

/**
 * This program will change every single menu's PSST in
 * every single CX Model in your account to your specified
 * value. THIS CANNOT BE UNDONE! Used to show the bulk change
 * capabilities of the API's exporting and importing of
 * CX Model JSON.
 * <p>
 * This is not an official Cyara product and is not officially supported.
 * It is used for demonstration and training purposes. For assistance,
 * contact chris.ryan@cyara.com
 * 
 * @author Chris Ryan
 * @version 1.1
 */
public class ResetAllModelPSSTs {
	public static void main(String[] argv) {		
		ApiFunctionalities connInfo = new ApiFunctionalities();

		boolean morePages = true;
		String nextPage = "";
		JsonObject apiObject = connInfo.listCXModels();

		ArrayList<Integer> allModelIDs = new ArrayList<>();

		//Loop thru all the pages of CX Models, storing their IDs
		while (morePages) {
			if (apiObject.containsKey("nextPage")) {
				if (apiObject.isNull("nextPage")) {
					morePages = false;
				}
				else {
					nextPage = apiObject.getString("nextPage");
				}

				JsonArray modelsArr = apiObject.getJsonArray("results");

				for (int modelIndex = 0; modelIndex < modelsArr.size(); modelIndex++) {
					JsonObject testCaseInCampaign = modelsArr.getJsonObject(modelIndex);
					int blockID = testCaseInCampaign.getInt("modelId");
					allModelIDs.add(blockID);
				}
			}
			else { //nextPage doesn't even exist, something is totally wrong
				morePages = false;
			}

			if (morePages) { //After processing that call, do we still have pages? Then make the next call here
				apiObject = connInfo.convertAPIOutputToJson(connInfo.makeApiGet(nextPage));
			}
		}

		//Loop thru all CX Model IDs and process
		for (int modelIndex = 0; modelIndex < allModelIDs.size(); modelIndex++) {
			int cxModelId = allModelIDs.get(modelIndex);

			//Export the CX Model and convert to string
			String rawCXModelJson = connInfo.exportCXModel(cxModelId).toString();

			//Replace any and all PSST values in the model to our new PSST
			rawCXModelJson = rawCXModelJson.replaceAll("\"minPsst\":.*?,", "\"minPsst\":1.5000,"); //Change 1.5000 to your desired PSST

			//Debug printouts
			System.out.println("FINALLY");
			System.out.println(rawCXModelJson);

			//Import the newly changed CX Model
			connInfo.importCXModel(rawCXModelJson, "OverrideExisting");
		}
	}

}
